Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/locales/en/LC_MESSAGES/waeup.fceokene.po
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/locales/en/LC_MESSAGES/waeup.fceokene.po	(revision 9388)
+++ 	(revision )
@@ -1,138 +1,0 @@
-# #############################################################################
-#
-# Copyright (c) 2003-2004 Zope Corporation and Contributors.
-# All Rights Reserved.
-#
-# This software is subject to the provisions of the Zope Public License,
-# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
-# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
-# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
-# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
-# FOR A PARTICULAR PURPOSE.
-#
-# #############################################################################
-msgid ""
-msgstr ""
-"Project-Id-Version: Development/Unknown\n"
-"POT-Creation-Date: Mon Sep  3 12:52:46 2012\n"
-"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
-"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
-"Language-Team: Zope 3 Developers <zope3-dev@zope.org>\n"
-"Language: \n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-"Generated-By: zope/app/locales/extract.py\n"
-
-#: waeup/fceokene/browser/theming.py:30
-msgid "FCEOkene Theme"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:35
-msgid "School Fee (ignored)"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:41
-msgid "Application Fee (fallback)"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:47
-msgid "Clearance Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:53
-msgid "Booking Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:61
-msgid "Maintenance Fee (ignored)"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:67
-msgid "Gown Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:73
-msgid "Transfer Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:88
-msgid "Academic Session"
-msgstr ""
-
-#. Default: ""
-#: waeup/fceokene/interswitch/browser.py:103
-msgid "Unsuccessful callback: ${a}"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:108
-msgid "Callback amount does not match."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:113
-msgid "Callback transaction id does not match."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:119
-msgid "Successful callback received"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:128
-#: waeup/fceokene/interswitch/browser.py:142
-msgid "CollegePAY"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:156
-#: waeup/fceokene/interswitch/browser.py:164
-msgid "Requery CollegePAY"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:175
-#: waeup/fceokene/interswitch/browser.py:254
-msgid "Submit data to CollegePAY (Interswitch Payment Gateway)"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:176
-#: waeup/fceokene/interswitch/browser.py:255
-msgid "Submit"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:186
-#: waeup/fceokene/interswitch/browser.py:264
-msgid "Payment ticket can't be re-send to CollegePAY."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:269
-msgid ""
-"Payment ticket can't be send to CollegePAY. Application period has expired."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:315
-#: waeup/fceokene/interswitch/browser.py:342
-msgid "This ticket has already been paid."
-msgstr ""
-
-#. Default: ""
-#: waeup/fceokene/interswitch/browser.py:94
-msgid "Invalid callback: ${a}"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:74
-msgid "Payment Level"
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:194
-msgid "Amount could not be determined."
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:201
-msgid "This type of payment has already been made."
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:66
-msgid "Session configuration object is not available."
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:80 waeup/fceokene/students/utils.py:86
-msgid "Study course data are incomplete."
-msgstr ""
Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/locales/fr/LC_MESSAGES/waeup.fceokene.po
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/locales/fr/LC_MESSAGES/waeup.fceokene.po	(revision 9388)
+++ 	(revision )
@@ -1,138 +1,0 @@
-# #############################################################################
-#
-# Copyright (c) 2003-2004 Zope Corporation and Contributors.
-# All Rights Reserved.
-#
-# This software is subject to the provisions of the Zope Public License,
-# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
-# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
-# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
-# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
-# FOR A PARTICULAR PURPOSE.
-#
-# #############################################################################
-msgid ""
-msgstr ""
-"Project-Id-Version: Development/Unknown\n"
-"POT-Creation-Date: Mon Sep  3 12:52:46 2012\n"
-"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
-"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
-"Language-Team: Zope 3 Developers <zope3-dev@zope.org>\n"
-"Language: \n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-"Generated-By: zope/app/locales/extract.py\n"
-
-#: waeup/fceokene/browser/theming.py:30
-msgid "FCEOkene Theme"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:35
-msgid "School Fee (ignored)"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:41
-msgid "Application Fee (fallback)"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:47
-msgid "Clearance Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:53
-msgid "Booking Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:61
-msgid "Maintenance Fee (ignored)"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:67
-msgid "Gown Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:73
-msgid "Transfer Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:88
-msgid "Academic Session"
-msgstr ""
-
-#. Default: ""
-#: waeup/fceokene/interswitch/browser.py:103
-msgid "Unsuccessful callback: ${a}"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:108
-msgid "Callback amount does not match."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:113
-msgid "Callback transaction id does not match."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:119
-msgid "Successful callback received"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:128
-#: waeup/fceokene/interswitch/browser.py:142
-msgid "CollegePAY"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:156
-#: waeup/fceokene/interswitch/browser.py:164
-msgid "Requery CollegePAY"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:175
-#: waeup/fceokene/interswitch/browser.py:254
-msgid "Submit data to CollegePAY (Interswitch Payment Gateway)"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:176
-#: waeup/fceokene/interswitch/browser.py:255
-msgid "Submit"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:186
-#: waeup/fceokene/interswitch/browser.py:264
-msgid "Payment ticket can't be re-send to CollegePAY."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:269
-msgid ""
-"Payment ticket can't be send to CollegePAY. Application period has expired."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:315
-#: waeup/fceokene/interswitch/browser.py:342
-msgid "This ticket has already been paid."
-msgstr ""
-
-#. Default: ""
-#: waeup/fceokene/interswitch/browser.py:94
-msgid "Invalid callback: ${a}"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:74
-msgid "Payment Level"
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:194
-msgid "Amount could not be determined."
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:201
-msgid "This type of payment has already been made."
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:66
-msgid "Session configuration object is not available."
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:80 waeup/fceokene/students/utils.py:86
-msgid "Study course data are incomplete."
-msgstr ""
Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/locales/ha/LC_MESSAGES/waeup.fceokene.po
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/locales/ha/LC_MESSAGES/waeup.fceokene.po	(revision 9388)
+++ 	(revision )
@@ -1,138 +1,0 @@
-# #############################################################################
-#
-# Copyright (c) 2003-2004 Zope Corporation and Contributors.
-# All Rights Reserved.
-#
-# This software is subject to the provisions of the Zope Public License,
-# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
-# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
-# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
-# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
-# FOR A PARTICULAR PURPOSE.
-#
-# #############################################################################
-msgid ""
-msgstr ""
-"Project-Id-Version: Development/Unknown\n"
-"POT-Creation-Date: Mon Sep  3 12:52:46 2012\n"
-"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
-"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
-"Language-Team: Zope 3 Developers <zope3-dev@zope.org>\n"
-"Language: \n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-"Generated-By: zope/app/locales/extract.py\n"
-
-#: waeup/fceokene/browser/theming.py:30
-msgid "FCEOkene Theme"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:35
-msgid "School Fee (ignored)"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:41
-msgid "Application Fee (fallback)"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:47
-msgid "Clearance Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:53
-msgid "Booking Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:61
-msgid "Maintenance Fee (ignored)"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:67
-msgid "Gown Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:73
-msgid "Transfer Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:88
-msgid "Academic Session"
-msgstr ""
-
-#. Default: ""
-#: waeup/fceokene/interswitch/browser.py:103
-msgid "Unsuccessful callback: ${a}"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:108
-msgid "Callback amount does not match."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:113
-msgid "Callback transaction id does not match."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:119
-msgid "Successful callback received"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:128
-#: waeup/fceokene/interswitch/browser.py:142
-msgid "CollegePAY"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:156
-#: waeup/fceokene/interswitch/browser.py:164
-msgid "Requery CollegePAY"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:175
-#: waeup/fceokene/interswitch/browser.py:254
-msgid "Submit data to CollegePAY (Interswitch Payment Gateway)"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:176
-#: waeup/fceokene/interswitch/browser.py:255
-msgid "Submit"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:186
-#: waeup/fceokene/interswitch/browser.py:264
-msgid "Payment ticket can't be re-send to CollegePAY."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:269
-msgid ""
-"Payment ticket can't be send to CollegePAY. Application period has expired."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:315
-#: waeup/fceokene/interswitch/browser.py:342
-msgid "This ticket has already been paid."
-msgstr ""
-
-#. Default: ""
-#: waeup/fceokene/interswitch/browser.py:94
-msgid "Invalid callback: ${a}"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:74
-msgid "Payment Level"
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:194
-msgid "Amount could not be determined."
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:201
-msgid "This type of payment has already been made."
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:66
-msgid "Session configuration object is not available."
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:80 waeup/fceokene/students/utils.py:86
-msgid "Study course data are incomplete."
-msgstr ""
Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/locales/yo/LC_MESSAGES/waeup.fceokene.po
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/locales/yo/LC_MESSAGES/waeup.fceokene.po	(revision 9388)
+++ 	(revision )
@@ -1,138 +1,0 @@
-# #############################################################################
-#
-# Copyright (c) 2003-2004 Zope Corporation and Contributors.
-# All Rights Reserved.
-#
-# This software is subject to the provisions of the Zope Public License,
-# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
-# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
-# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
-# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
-# FOR A PARTICULAR PURPOSE.
-#
-# #############################################################################
-msgid ""
-msgstr ""
-"Project-Id-Version: Development/Unknown\n"
-"POT-Creation-Date: Mon Sep  3 12:52:46 2012\n"
-"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
-"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
-"Language-Team: Zope 3 Developers <zope3-dev@zope.org>\n"
-"Language: \n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-"Generated-By: zope/app/locales/extract.py\n"
-
-#: waeup/fceokene/browser/theming.py:30
-msgid "FCEOkene Theme"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:35
-msgid "School Fee (ignored)"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:41
-msgid "Application Fee (fallback)"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:47
-msgid "Clearance Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:53
-msgid "Booking Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:61
-msgid "Maintenance Fee (ignored)"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:67
-msgid "Gown Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:73
-msgid "Transfer Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:88
-msgid "Academic Session"
-msgstr ""
-
-#. Default: ""
-#: waeup/fceokene/interswitch/browser.py:103
-msgid "Unsuccessful callback: ${a}"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:108
-msgid "Callback amount does not match."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:113
-msgid "Callback transaction id does not match."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:119
-msgid "Successful callback received"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:128
-#: waeup/fceokene/interswitch/browser.py:142
-msgid "CollegePAY"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:156
-#: waeup/fceokene/interswitch/browser.py:164
-msgid "Requery CollegePAY"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:175
-#: waeup/fceokene/interswitch/browser.py:254
-msgid "Submit data to CollegePAY (Interswitch Payment Gateway)"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:176
-#: waeup/fceokene/interswitch/browser.py:255
-msgid "Submit"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:186
-#: waeup/fceokene/interswitch/browser.py:264
-msgid "Payment ticket can't be re-send to CollegePAY."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:269
-msgid ""
-"Payment ticket can't be send to CollegePAY. Application period has expired."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:315
-#: waeup/fceokene/interswitch/browser.py:342
-msgid "This ticket has already been paid."
-msgstr ""
-
-#. Default: ""
-#: waeup/fceokene/interswitch/browser.py:94
-msgid "Invalid callback: ${a}"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:74
-msgid "Payment Level"
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:194
-msgid "Amount could not be determined."
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:201
-msgid "This type of payment has already been made."
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:66
-msgid "Session configuration object is not available."
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:80 waeup/fceokene/students/utils.py:86
-msgid "Study course data are incomplete."
-msgstr ""