Index: /main/waeup.futminna/trunk/src/waeup/futminna/interswitch/browser.py
===================================================================
--- /main/waeup.futminna/trunk/src/waeup/futminna/interswitch/browser.py	(revision 9409)
+++ /main/waeup.futminna/trunk/src/waeup/futminna/interswitch/browser.py	(revision 9410)
@@ -263,17 +263,10 @@
             self.pay_item_id = "11706"
 
-        elif self.context.p_category == 'hostel_maintenance':
+        elif 'maintenance' in self.context.p_category:
             xmldict['institution_amt'] = 100 * (
                 self.context.amount_auth - 300)
-            xmldict['institution_acct'] = "0000000000000"
-            xmldict['institution_bank_id'] = '00'
-            self.pay_item_id = "0000"
-
-        elif self.context.p_category == 'block_h_maintenance':
-            xmldict['institution_amt'] = 100 * (
-                self.context.amount_auth - 300)
-            xmldict['institution_acct'] = "0000000000000"
-            xmldict['institution_bank_id'] = '00'
-            self.pay_item_id = "0000"
+            xmldict['institution_acct'] = "2018856637"
+            xmldict['institution_bank_id'] = '8'
+            self.pay_item_id = "11705"
 
         xmldict['institution_name'] = INSTITUTION_NAME
@@ -298,5 +291,5 @@
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="Maintenance Fee" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
+<item_detail item_id="1" item_name="Hostel Maintenance Fee" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
 </item_details>
 </payment_item_detail>""" % xmldict
Index: /main/waeup.futminna/trunk/src/waeup/futminna/interswitch/tests.py
===================================================================
--- /main/waeup.futminna/trunk/src/waeup/futminna/interswitch/tests.py	(revision 9409)
+++ /main/waeup.futminna/trunk/src/waeup/futminna/interswitch/tests.py	(revision 9410)
@@ -99,6 +99,4 @@
         # Manager can access InterswitchForm
         self.browser.getLink("CollegePAY", index=0).click()
-        self.assertMatches('...Total Amount Authorized:...',
-                           self.browser.contents)
         # The total amount to be processed by Interswitch
         # has been reduced by the Interswitch fee of 150 Nairas
@@ -114,4 +112,33 @@
         self.assertFalse("BT Education" in self.browser.contents)
 
+        # Create hostel maintenance ticket
+        self.browser.open(self.payments_path + '/addop')
+        self.browser.getControl(name="form.p_category").value = ['hostel_maintenance']
+        self.browser.getControl("Create ticket").click()
+        self.assertMatches('...ticket created...',
+                           self.browser.contents)
+        ctrl = self.browser.getControl(name='val_id')
+        value = ctrl.options[2]
+        self.browser.getLink(value).click()
+        self.assertMatches('...Amount Authorized...',
+                           self.browser.contents)
+        self.assertMatches(
+            '...<span>10000.0</span>...',
+            self.browser.contents)
+        # Manager can access InterswitchForm
+        self.browser.getLink("CollegePAY", index=0).click()
+        # The total amount to be processed by Interswitch
+        # has been reduced by the Interswitch fee of 150 Nairas
+        self.assertMatches('...Total Amount Authorized:...',
+                           self.browser.contents)
+        self.assertMatches(
+            '...<input type="hidden" name="amount" value="1000000.0" />...',
+            self.browser.contents)
+        self.assertMatches(
+            '...item_name="Hostel Maintenance Fee" item_amt="970000" bank_id="8" acct_num="2018856637"...',
+            self.browser.contents)
+        # BT does nor charge a fee for clearance
+        self.assertFalse("BT Education" in self.browser.contents)
+
 
     @external_test