Index: main/waeup.uniben/trunk/src/waeup/uniben/interfaces.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/interfaces.py	(revision 9407)
+++ main/waeup.uniben/trunk/src/waeup/uniben/interfaces.py	(revision 9435)
@@ -56,6 +56,4 @@
         )
 
-    # Additional fees in custom package
-
     maint_fee = schema.Float(
         title = _(u'Maintenance Fee (ignored)'),
@@ -63,4 +61,6 @@
         required = False,
         )
+
+    # Additional fees in custom package
 
     gown_fee = schema.Float(
Index: main/waeup.uniben/trunk/src/waeup/uniben/interswitch/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/interswitch/browser.py	(revision 9407)
+++ main/waeup.uniben/trunk/src/waeup/uniben/interswitch/browser.py	(revision 9435)
@@ -118,5 +118,6 @@
     payment.payment_date = datetime.utcnow()
     msg = _('Successful callback received')
-    log = 'valid callback for payment %s: %s' % (payment.p_id, sr)
+    log = 'valid callback for %s payment %s: %s' % (
+        payment.p_category, payment.p_id, sr)
     return True, msg, log
 
Index: main/waeup.uniben/trunk/src/waeup/uniben/interswitch/tests.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/interswitch/tests.py	(revision 9407)
+++ main/waeup.uniben/trunk/src/waeup/uniben/interswitch/tests.py	(revision 9435)
@@ -54,5 +54,15 @@
         self.browser.getControl(name="form.p_category").value = ['schoolfee']
         self.browser.getControl("Create ticket").click()
-
+        self.assertMatches('...ticket created...',
+                           self.browser.contents)
+        ctrl = self.browser.getControl(name='val_id')
+        value = ctrl.options[0]
+        self.browser.getLink(value).click()
+        self.assertMatches('...Amount Authorized...',
+                           self.browser.contents)
+        self.assertMatches(
+            '...<span>40000.0</span>...',
+            self.browser.contents)
+        self.payment_url = self.browser.url
 
 #    def callback_url(self, payment_url, resp, apprAmt):
@@ -68,17 +78,4 @@
 
     def test_interswitch_form(self):
-
-        # School fee ticket already created in setUp method
-        self.assertMatches('...ticket created...',
-                           self.browser.contents)
-        ctrl = self.browser.getControl(name='val_id')
-        value = ctrl.options[0]
-        self.browser.getLink(value).click()
-        self.assertMatches('...Amount Authorized...',
-                           self.browser.contents)
-        self.assertMatches(
-            '...<span>40000.0</span>...',
-            self.browser.contents)
-        self.payment_url = self.browser.url
         # Manager can access InterswitchForm
         self.browser.getLink("CollegePAY", index=0).click()
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py	(revision 9407)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py	(revision 9435)
@@ -29,4 +29,5 @@
 from waeup.kofa.app import University
 from waeup.kofa.students.tests.test_browser import StudentsFullSetup
+from waeup.kofa.students.accommodation import BedTicket
 from waeup.kofa.testing import FunctionalTestCase
 from waeup.kofa.interfaces import (
@@ -72,4 +73,14 @@
 
     layer = FunctionalLayer
+
+    def setUp(self):
+        super(StudentUITests, self).setUp()
+
+        bedticket = BedTicket()
+        bedticket.booking_session = 2004
+        bedticket.bed_type = u'any bed type'
+        bedticket.bed = self.app['hostels']['hall-1']['hall-1_A_101_A']
+        bedticket.bed_coordinates = u'My bed coordinates'
+        self.student['accommodation'].addBedTicket(bedticket)
 
     def test_next_session_allowed(self):