Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/interfaces.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/interfaces.py	(revision 9179)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/interfaces.py	(revision 9449)
@@ -104,5 +104,5 @@
         source = nats_vocab,
         title = _(u'Nationality'),
-        required = False,
+        required = True,
         )
     lga = schema.Choice(
@@ -216,5 +216,5 @@
         source = nats_vocab,
         title = _(u'Nationality'),
-        required = False,
+        required = True,
         )
     lga = schema.Choice(
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/tests/test_browser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/tests/test_browser.py	(revision 9179)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/tests/test_browser.py	(revision 9449)
@@ -311,4 +311,5 @@
         applicant.lastname = u'Tester'
         applicant.middlename = u'M.'
+        applicant.nationality = u'NG'
         applicant.date_of_birth = datetime.date(1981, 2, 4)
         applicant.sex = 'f'
@@ -332,26 +333,22 @@
         exporter.export_all(self.app, self.outfile)
         result = open(self.outfile, 'rb').read()
-        # The exported records do contain a real date in their
-        # history dict. We skip the date and split the comparison
-        # into two parts.
-        self.assertTrue(
-            'aggregate,applicant_id,application_date,application_number,course1,course2,'
-            'course_admitted,date_of_birth,display_fullname,email,emp2_end,'
-            'emp2_position,emp2_reason,emp2_start,emp_end,emp_position,'
-            'emp_reason,emp_start,employer,employer2,firstname,history,'
-            'hq_degree,hq_disc,hq_matric_no,hq_school,hq_session,hq_type,'
-            'jamb_score,jamb_subjects,lastname,lga,locked,middlename,'
-            'nationality,notice,nysc_lga,'
-            'nysc_year,password,phone,pp_school,presently_inst,'
-            'reg_number,result_uploaded,screening_date,screening_score,screening_venue,sex,'
-            'state,student_id,'
-            'suspended,container_code'
-            in result)
-        self.assertTrue(
-            'Application initialized by system\'],,,,,,,,,Tester,,0,M.,,'
-            '"Some notice\nin lines.",,,any password,+234-123-12345#,,,'
-            '123456,,"Saturday, 16th June 2012 2:00:00 PM",98,Exam Room,f,'
-            'initialized,,0,dp2011'
-            in result)
+        self.assertMatches(result,
+            'aggregate,applicant_id,application_date,application_number,'
+            'course1,course2,course_admitted,date_of_birth,display_fullname,'
+            'email,emp2_end,emp2_position,emp2_reason,emp2_start,emp_end,'
+            'emp_position,emp_reason,emp_start,employer,employer2,'
+            'firstname,history,hq_degree,hq_disc,hq_matric_no,hq_school,'
+            'hq_session,hq_type,jamb_score,jamb_subjects,lastname,lga,'
+            'locked,middlename,nationality,notice,nysc_lga,nysc_year,'
+            'password,phone,pp_school,presently_inst,reg_number,'
+            'result_uploaded,screening_date,screening_score,'
+            'screening_venue,sex,state,student_id,suspended,container_code\r\n'
+            ',dp2011_654321,,654321,CERT1,CERT1,CERT1,1981-02-04#,'
+            'Anna M. Tester,anna@sample.com,,,,,,,,,,,Anna,'
+            '[u\'2012-10-28 21:27:52 WAT - Application initialized by system\']'
+            ',,,,,,,,,Tester,,0,M.,NG,"Some notice\nin lines.",,,'
+            'any password,+234-123-12345#,,,123456,,'
+            '"Saturday, 16th June 2012 2:00:00 PM",98,Exam Room,f,initialized,,'
+            '0,dp2011\r\n')
         # We can import the same file if we ignore some columns.
         # Since the applicants_catalog hasn't been notified, the same
@@ -374,4 +371,5 @@
             mode='create')
         num_succ, num_fail, finished_path, failed_path = result
+        #content = open(failed_path).read()
         self.assertEqual(num_succ,1)
         self.assertEqual(num_fail,0)