Index: main/waeup.uniben/trunk/src/waeup/uniben/interswitch/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/interswitch/browser.py	(revision 9453)
+++ main/waeup.uniben/trunk/src/waeup/uniben/interswitch/browser.py	(revision 9460)
@@ -235,42 +235,27 @@
         xmldict['institution_amt'] = '0.0'
         if self.context.p_category == 'schoolfee':
-            if student.current_mode.endswith('_ft') \
-                and student.state == RETURNING:
-                provider_amt = 600
-            else:
-                provider_amt = 1500
-            #studycourse = student['studycourse']
+            provider_amt = 1500
             if student.current_mode.endswith('_ft'):
                 self.pay_item_id = '5700'
-                #post-grad full-time students of all faculties
-                if student.is_postgrad:
-                    xmldict['institution_acct'] = '1012842833'
-                    xmldict['institution_bank_id'] = '117'
-                #all other part-time students depending on faculty
-                elif student.faccode in ('SSC','LAW','MED'):
-                    xmldict['institution_acct'] = '0005986938'
-                    xmldict['institution_bank_id'] = '31'
-                elif student.faccode in ('ENG','PSC','PHA'):
-                    xmldict['institution_acct'] = '0014413973'
-                    xmldict['institution_bank_id'] = '129'
-                elif student.faccode in ('LSC','DEN','AGR'):
-                    xmldict['institution_acct'] = '1012801319'
-                    xmldict['institution_bank_id'] = '117'
-                elif student.faccode in ('ART','EDU','MGS','BMS'):
-                    xmldict['institution_acct'] = '6220027556'
+                if student.current_mode in ('ug_ft','de_ft','ct_ft','ume_ft'):
+                    xmldict['institution_acct'] = '2017506430'
+                    xmldict['institution_bank_id'] = '8'
+                elif student.current_mode in ('dp_ft'):
+                    xmldict['institution_acct'] = '9201805071'
+                    xmldict['institution_bank_id'] = '17'
+                elif student.current_mode in ('pg_ft'):
+                    xmldict['institution_acct'] = '5330832799'
                     xmldict['institution_bank_id'] = '51'
             elif student.current_mode.endswith('_pt'):
                 self.pay_item_id = '5701'
-                #post-grad part-time students of all faculties
-                if student.is_postgrad:
-                    xmldict['institution_acct'] = '0023708207'
-                    xmldict['institution_bank_id'] = '72'
-                #all other part-time students depending on faculty
-                elif student.faccode in ('ENG','LAW','MGS'):
-                    xmldict['institution_acct'] = '2019006824'
-                    xmldict['institution_bank_id'] = '8'
-                elif student.faccode in ('IPA','PHA','SSC','AGR','EDU'):
-                    xmldict['institution_acct'] = '0122012109'
+                if student.current_mode in ('ug_pt','de_pt','ct_pt'):
+                    xmldict['institution_acct'] = '0122009929'
                     xmldict['institution_bank_id'] = '16'
+                elif student.current_mode in ('dp_pt'):
+                    xmldict['institution_acct'] = '9201805071'
+                    xmldict['institution_bank_id'] = '17'
+                elif student.current_mode in ('pg_pt'):
+                    xmldict['institution_acct'] = '0031716047'
+                    xmldict['institution_bank_id'] = '10'
         elif self.context.p_category == 'clearance':
             self.pay_item_id = '5702'
Index: main/waeup.uniben/trunk/src/waeup/uniben/interswitch/tests.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/interswitch/tests.py	(revision 9453)
+++ main/waeup.uniben/trunk/src/waeup/uniben/interswitch/tests.py	(revision 9460)
@@ -86,9 +86,10 @@
         self.assertMatches('...Total Amount Authorized:...',
                            self.browser.contents)
+        self.assertEqual(self.student.current_mode, 'ug_ft')
         self.assertMatches(
             '...<input type="hidden" name="amount" value="4000000.0" />...',
             self.browser.contents)
         self.assertMatches(
-            '...item_name="School Fee" item_amt="3835000" bank_id="00" acct_num="000000000000"...',
+            '...item_name="School Fee" item_amt="3835000" bank_id="8" acct_num="2017506430"...',
             self.browser.contents)
         self.assertMatches(
@@ -115,5 +116,5 @@
             self.browser.contents)
         self.assertMatches(
-            '...item_name="School Fee" item_amt="1835000" bank_id="00" acct_num="000000000000"...',
+            '...item_name="School Fee" item_amt="1835000" bank_id="16" acct_num="0122009929"...',
             self.browser.contents)
         self.assertMatches(